'use strict';

exports.__esModule = true;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _electron = require('electron');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var rmDir = function rmDir(dirPath, removeSelf) {
    console.info('Clearing folder ' + dirPath);
    if (removeSelf === undefined) {
        removeSelf = true;
    }

    var files = void 0;
    try {
        files = _fs2.default.readdirSync(dirPath);
        console.info('Removing files: ' + files);
    } catch (e) {
        return;
    }

    if (files.length > 0) {
        for (var i = 0; i < files.length; i++) {
            var filePath = dirPath + '/' + files[i];
            if (_fs2.default.statSync(filePath).isFile()) {
                _fs2.default.unlinkSync(filePath);
            } else {
                rmDir(filePath);
            }
        }
    }
    if (removeSelf) {
        _fs2.default.rmdirSync(dirPath);
    }
};

// platform related

var DataStorage = function () {
    function DataStorage() {
        (0, _classCallCheck3.default)(this, DataStorage);
    }

    DataStorage.init = function init() {
        // Create the user data directory if it does not exist
        this.userDataDir = _electron.app.getPath('userData');
        _mkdirp2.default.sync(this.userDataDir);

        this.tmpDir = this.userDataDir + '/Tmp';
        this.sessionDir = this.userDataDir + '/Sessions';

        _mkdirp2.default.sync(this.tmpDir);
        _mkdirp2.default.sync(this.sessionDir);

        this.clear();
    };

    DataStorage.clear = function clear() {
        try {
            rmDir(this.tmpDir, false);
            rmDir(this.sessionDir, false);
        } catch (e) {
            console.error(e);
        }
    };

    return DataStorage;
}();

exports.default = DataStorage;