'use strict';

exports.__esModule = true;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _electron = require('electron');

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

var _log = require('./log');

var _log2 = _interopRequireDefault(_log);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var notify = function notify(title, message) {
    var windows = _electron.BrowserWindow.getAllWindows();
    if (windows.length === 0) {
        return;
    }

    windows[0].webContents.send('notify', title, message);
}; /* eslint import/no-unresolved: 0 */

var AutoUpdater = function AutoUpdater(window) {
    (0, _classCallCheck3.default)(this, AutoUpdater);

    if (process.platform !== 'darwin') {
        return;
    }

    _electron.autoUpdater.addListener('update-available', function () {
        _log2.default.debug('A new update is available');
    });
    // On Windows only `releaseName` is available.
    _electron.autoUpdater.addListener('update-downloaded', function (event, releaseNotes, releaseName) {
        var title = 'A new update is ready to install';
        var message = 'Version ' + releaseName + ' is downloaded and will be automatically installed on quit';
        notify(title, message);
    });
    _electron.autoUpdater.addListener('error', function (err) {
        _log2.default.error(err);
    });
    _electron.autoUpdater.addListener('checking-for-update', function () {
        _log2.default.debug('checking-for-update');
    });
    _electron.autoUpdater.addListener('update-not-available', function () {
        _log2.default.debug('update-not-available');
    });

    var updateServerHost = ''; // FIXME
    var platform = _os2.default.platform();
    var arch = _os2.default.arch();
    var version = _electron.app.getVersion();
    var feedURL = 'https://' + updateServerHost + '/update/' + platform + '-' + arch + '/' + version;
    _electron.autoUpdater.setFeedURL(feedURL);

    window.webContents.once('did-frame-finish-load', function () {
        _electron.autoUpdater.checkForUpdates();
    });
};

exports.default = AutoUpdater;