'use strict';

exports.__esModule = true;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = getMenuTemplate;

var _electron = require('electron');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getMenuTemplate(options) {
    var _options = (0, _extends3.default)({}, options),
        address = _options.address,
        port = _options.port;

    var template = [{
        label: 'Edit',
        submenu: [{ role: 'undo' }, { role: 'redo' }, { type: 'separator' }, { role: 'cut' }, { role: 'copy' }, { role: 'paste' }, { role: 'pasteandmatchstyle' }, { role: 'selectall' }]
    }, {
        label: 'View',
        submenu: [{ role: 'reload' }, { role: 'forcereload' }, { type: 'separator' }, { role: 'resetzoom' }, { role: 'zoomin' }, { role: 'zoomout' }, { type: 'separator' }, { role: 'togglefullscreen' }, { type: 'separator' }, {
            label: 'View In Browser',
            click: function click() {
                var url = 'http://' + address + ':' + port;
                _electron.shell.openExternal(url);
            }
        }, { role: 'toggledevtools' }]
    }, {
        role: 'window',
        submenu: [{ role: 'minimize' }, { role: 'close' }]
    }];

    if (process.platform === 'darwin') {
        // About
        template.unshift({
            label: _electron.app.getName(),
            submenu: [{ role: 'about' }, { type: 'separator' }, { role: 'services', submenu: [] }, { type: 'separator' }, {
                role: 'hide',
                label: 'Hide'
            }, { role: 'hideothers' }, { role: 'unhide' }, { type: 'separator' }, {
                role: 'quit',
                label: 'Quit'
            }]
        });

        // View
        var viewMenu = template[3];
        viewMenu.submenu.push({ type: 'separator' });
        viewMenu.submenu.push({ role: 'front' });
    }

    return template;
}