'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

require('babel-polyfill');

var _electron = require('electron');

var _window = require('./electron-app/window');

var _Menu = require('./electron-app/Menu');

var _Menu2 = _interopRequireDefault(_Menu);

var _serverCli = require('./server-cli');

var _serverCli2 = _interopRequireDefault(_serverCli);

var _DataStorage = require('./DataStorage');

var _DataStorage2 = _interopRequireDefault(_DataStorage);

var _package = require('./package.json');

var _package2 = _interopRequireDefault(_package);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var windowInstance = null; /* eslint import/no-unresolved: 0 */

var lastURL = null;
var options = {
    width: 1280,
    height: 768,
    title: _package2.default.name + ' ' + _package2.default.version
};

function openBrowserWindow(url) {
    var window = new _electron.BrowserWindow((0, _extends3.default)({}, options, {
        show: false
    }));

    (0, _window.configureWindow)(window);

    // Ignore proxy settings
    // https://electronjs.org/docs/api/session#sessetproxyconfig-callback
    var session = window.webContents.session;
    session.setProxy({ proxyRules: 'direct://' }, function () {
        window.loadURL(url);
        window.show();
    });

    return window;
}

var onReady = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var data, _data, address, port, routes, template, menu, url;

        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        _context.prev = 0;

                        // TODO: parse command arguments
                        // TODO: create server
                        // TODO: start services
                        _DataStorage2.default.init();

                        _context.next = 4;
                        return (0, _serverCli2.default)();

                    case 4:
                        data = _context.sent;
                        _data = (0, _extends3.default)({}, data), address = _data.address, port = _data.port, routes = _data.routes;

                        // Menu

                        template = (0, _Menu2.default)({ address: address, port: port, routes: routes });
                        menu = _electron.Menu.buildFromTemplate(template);

                        _electron.Menu.setApplicationMenu(menu);

                        url = 'http://' + address + ':' + port;

                        windowInstance = openBrowserWindow(url);

                        lastURL = url;
                        _context.next = 17;
                        break;

                    case 14:
                        _context.prev = 14;
                        _context.t0 = _context['catch'](0);

                        console.error('Error: ', _context.t0);

                    case 17:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, undefined, [[0, 14]]);
    }));

    return function onReady() {
        return _ref.apply(this, arguments);
    };
}();

var main = function main() {
    // https://github.com/electron/electron/blob/master/docs/api/app.md#apprequestsingleinstancelock
    /*
    // Electron 4
    const gotTheLock = app.requestSingleInstanceLock();
     if (!gotTheLock) {
        app.quit();
        return;
    }
     app.on('second-instance', (event, commandLine, workingDirectory) => {
        // Someone tried to run a second instance, we should focus our window.
        if (!windowManager) {
            return;
        }
         const myWindow = windowManager.getWindow();
        if (myWindow) {
            if (myWindow.isMinimized()) {
                myWindow.restore();
            }
            myWindow.focus();
        }
    });
    */

    // Electron 2
    // Allow multiple instances for controlling more machines
    /*
    const shouldQuit = app.makeSingleInstance(() => {
        if (window) {
            if (window.isMinimized()) {
                window.restore();
            }
            window.focus();
        }
    });
     if (shouldQuit) {
        app.quit();
        return;
    }
    */

    // Allow max 4G memory usage
    if (process.arch === 'x64') {
        _electron.app.commandLine.appendSwitch('--js-flags', '--max-old-space-size=4096');
    }

    _electron.app.commandLine.appendSwitch('ignore-gpu-blacklist');
    _electron.app.on('ready', onReady);

    // https://github.com/electron/electron/blob/master/docs/api/app.md#event-activate-os-x
    // Emitted when the application is activated, which usually happens
    // when the user clicks on the application's dock icon.
    _electron.app.on('activate', function () {
        if (!windowInstance) {
            openBrowserWindow(lastURL);
        }
    });

    // https://github.com/electron/electron/blob/master/docs/api/app.md#event-window-all-closed
    // Emitted when all windows have been closed.
    // This event is only emitted when the application is not going to quit.
    // If the user pressed Cmd + Q, or the developer called app.quit(), Electron
    // will first try to close all the windows and then emit the will-quit event,
    // and in this case the window-all-closed event would not be emitted.
    _electron.app.on('window-all-closed', function () {
        _DataStorage2.default.clear();
        _electron.app.quit();
    });
};

main();